Subject: Re: [PATCH iproute2-next] bridge: fdb: Use 'struct ndmsg' for FDB dumping

From: Ido Schimmel <[email-masked]>
Date: Tue, 1 Jan 2019 07:55:49 +0200

On Mon, Dec 31, 2018 at 08:25:38PM -0800, Stephen Hemminger wrote:
> On Sun, 30 Dec 2018 18:03:47 -0700
> David Ahern <[email-masked]> wrote:
> 
> > On 12/30/18 10:14 AM, Ido Schimmel wrote:
> > > Since commit aea41afcfd6d ("ip bridge: Set NETLINK_GET_STRICT_CHK on
> > > socket") iproute2 uses strict checking on kernels that support it. This
> > > causes FDB dumping to fail [1], as iproute2 uses 'struct ifinfomsg'
> > > whereas the kernel expects 'struct ndmsg'.
> > > 
> > > Note that with this change iproute2 continues to work on old kernels
> > > that do not support strict checking, but contain the fix introduced in
> > > kernel commit bd961c9bc664 ("rtnetlink: fix rtnl_fdb_dump() for ndmsg
> > > header").
> 
> Sorry, I don't think that is good enough backward compatibility guarantee.
> Iproute2 should work on really old kernels like 2.6.32. If not then then iproute2
> utility is broken or the changes to the kernel API were incorrect.

I found two more issues for which I have patches. I tested with and
without strict checking and I'll test on some old kernels as well. No
intention to break backward compatibility. Will Cc you.

Thanks